package com.afp.ordermanagement.config;

import com.mongodb.reactivestreams.client.MongoClient;
import com.mongodb.reactivestreams.client.MongoClients;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.core.ReactiveMongoTemplate;
import org.springframework.data.mongodb.core.SimpleReactiveMongoDatabaseFactory;

@Configuration
public class MongoConfig {
    @Value("${spring.data.mongodb.database:myFirstDatabase}")
    public String database;

    @Value("${spring.data.mongodb.uri:mongodb+srv://user:password2021@cluster0.g23rm.mongodb.net/myFirstDatabase?}")
    public String uri;

    @Bean
    public SimpleReactiveMongoDatabaseFactory reactiveMongoDbFactory() {
        MongoClient mongoClient = MongoClients.create(uri);
        return new SimpleReactiveMongoDatabaseFactory(mongoClient, database);
    }

    @Bean
    public ReactiveMongoTemplate reactiveMongoTemplate() throws Exception {
        ReactiveMongoTemplate mongoTemplate = new ReactiveMongoTemplate(reactiveMongoDbFactory());
        return mongoTemplate;
    }
}
